<?php
namespace Teknisa\CRM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Filter;
use Teknisa\CRM\Controller\TeknisaCrud;

class RelatorioConsolidadoDeTarefasController extends TeknisaCrud {
    
    protected $dataSourceName = 'relatorioConsolidadoDeTarefas';
    protected $parameterBagColumns = array('CRM_NRORGTRAB', 'NRSEQCONTATO', 'NRSEQCLASSIFICATAREFA', 'TIPO', 'DTINIPERIODO', 'DTFIMPERIODO', 'DATATAREFA');
    
    
    public function __construct ($crudService, $parameterBag) {
        parent::__construct($crudService, $parameterBag);
        
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $filterData = $request->getFilterCriteria();
        $conditions = $filterData->getConditions();
        
        $filterData->addCondition('NRSEQCONTATO', null);
        $filterData->addCondition('DTINIPERIODO', null);
        $filterData->addCondition('DTFIMPERIODO', null);
        $filterData->addCondition('DATATAREFA', null);
        $filterData->addCondition('NRSEQCLASSIFICATAREFA', null);
        $filterData->addCondition('TIPO', null);
        
        foreach ($conditions as $key => &$condition) {
            if($condition['columnName'] === 'AGRUPOR'){
                if($condition["value"] == 'OPERADOR') {
                     $this->dataSourceName = 'relatorioConsolidadoDeTarefas';
                } else {
                     $this->dataSourceName = 'relatorioConsolidadoDeTarefasParcnegocio';
                }
            }
            
            if($condition['columnName'] === 'NRSEQCONTATO'){
                $filterData->addCondition('NRSEQCONTATO', implode($condition["value"], ','));
            }
            if($condition['columnName'] === 'NRSEQCLASSIFICATAREFA'){
                $filterData->addCondition('NRSEQCLASSIFICATAREFA', implode($condition["value"], ','));
            }
            if($condition['columnName'] === 'TIPO'){
                $filterData->addCondition('TIPO', $condition["value"]);
            }
            if($condition['columnName'] === 'DATATAREFA'){
                $filterData->addCondition('DTINIPERIODO', $condition["value"][0]);
                $filterData->addCondition('DTFIMPERIODO', $condition["value"][1]);
                $filterData->addCondition('DATATAREFA', null);
            }
        }
        
        parent::find($request, $response);
    }
}
