<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class ger10120SegmentoMercadoController extends TeknisaCrud {
    protected $dataSourceName = 'segmercado';
    
    public function __construct ($crudService, $parameterBag){
        $this->parameterBag  = $parameterBag;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function setSegmercado(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            foreach ($request->getDataSet()->getRows() as &$row) {
                if (array_key_exists('CDSEGMER', $row)) {
                    if ($row['__is_new']) {
                        $row['CDSEGMER'] = NovoCodigo::geraCodigo($row['NRORG'], "SEGMERCADO", 1, 5, false, true);
                    }
                } else {
                    $row['CDSEGMER'] = NovoCodigo::geraCodigo($row['NRORG'], "SEGMERCADO", 1, 5, false, true);
                }
            
            }

            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}