<?php
namespace Teknisa\CRM\Factory;


use Doctrine\ORM\EntityManager;

class crm00050002ReservaProspectFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection       = $entityManager->getConnection();
    }
    
    public function requestForInsertResaleProspect($paramsInsertResaleProspect){
        
        $insert = "INSERT INTO CRM_PROSPREVENDA (NRPROSPREVENDA, NRREVENDA, NRPARCNEGOCIO, CDPROSPECT, NRORG, DTINCLUSAO,
                   NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO)
                    VALUES (:NRPROSPREVENDA,
                            :NRREVENDA,
                            :NRPARCNEGOCIO,
                            :CDPROSPECT,
                            :NRORG,
                             SYSDATE,
                            :NRORGINCLUSAO,
                            :CDOPERINCLUSAO,
                            :IDATIVO)";
        
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertResaleProspect);
        }
        catch(\Exception $e){
            throw $e;
        };   
        
    }
    
    public function requestForSelectOperatorResaleNumber($paramsSelectResaleNumber){
        
        $select  = "SELECT NRREVENDA,
                           NMRAZSOCREVENDA
                      FROM CRM_REVENDA
                     WHERE CDOPERREVENDA = :CDOPERREVENDA";
                     
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsSelectResaleNumber);
            $resaleNumber = $std->fetchAll(); 
            
            return $resaleNumber;
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    

}
?>