/* global FileTree, Util, UtilDevTools, Configuration */
(function(){
    function FileTreeService(ElementFileService){
        var self = this;
        var lastItem;
        var treeItems = [];
        var DevToolsWindow = UtilDevTools.getDevToolsWindow();
        var fileUnloadedItems;

        this.setUnloadedItems = function(unloadedItems){
            fileUnloadedItems = unloadedItems;
        };
        this.getUnloadedItems = function(){
            return fileUnloadedItems;
        };

        this.setLastItem = function(item){
            lastItem = item;
            lastItem.path.shift();//JUAN
        };

        this.getLastItem = function(){
            return lastItem;
        };

        var setTreeItems = function(items){
            treeItems = items;
        };

        this.getTreeItems = function(){
            return treeItems;
        };

        this.getItemMetadata = function(item){
            var parent = self.getTreeItems()[0];
            return ElementFileService.getElementToEditor(item, parent);
        };

        this.loadTree = function(){
            var tree = DevToolsWindow.treeScript || {};
            tree = Object.keys(tree).map(function(key){
                return tree[key];
            });
            setTreeItems(tree);
        };
        this.updateTree = self.loadTree;

        this.getDefaultTreeItem = function(){
            var treeScript = Util.clone(window.treeScript);
            return FileTree.unsetParent(treeScript);
        };

        this.getTotalUnloadedItems = function(script){
            var hasSomeUnloadedItems = !script._element;
            var getTotalItems = function(item){
                var total = Object.keys(item).reduce(function(total, property){
                    var child = item[property];
                    if(child && child.showInDevTools){
                        total++;
                        hasSomeUnloadedItems = hasSomeUnloadedItems || !child.element;
                        return total + getTotalItems(child);
                    } else {
                        return total;
                    }
                }, 0);
                return total;
            };
            var totalUnloadedItems = getTotalItems(script);
            totalUnloadedItems = hasSomeUnloadedItems ? totalUnloadedItems : 0;
            return totalUnloadedItems;
        };
    }

    Configuration(function(DeveloperTreeService, ElementFileService){
        var instance = new FileTreeService(ElementFileService);
        DeveloperTreeService.insertTreeMode('files', instance);
    });
})();
